<?php

if (!defined('IN_KANCART')) {
    header('HTTP/1.1 404 Not Found');
    die();
}

class kancart_shoppingcart_addresses_update_action extends BaseAction {

    private function updateAddress($shippingAddressId, $address) {
        $checkoutService = ServiceFactory::factory('Checkout');
        $checkoutService->updateAddress($shippingAddressId, $address);
    }

    private function addAddress($shippingAddress) {
        $checkoutService = ServiceFactory::factory('Checkout');
        $checkoutService->addAddress($shippingAddress);
    }

    public function execute() {
        $shippingAddressBookId = $this->getParam('shipping_address_book_id');
        if ($shippingAddressBookId) {
            $shippingAddressJson = $this->getParam('shipping_address');
            $shippingAddress = array();
            if ($shippingAddressJson) {
                $this->exportAddressToRequest(json_decode(urldecode(stripslashes($shippingAddressJson)), true));
                $shippingAddress = prepare_address();
            }
            $this->updateAddress($shippingAddressBookId, $shippingAddress);
        } else {
            //add a new address to db
            $shippingAddressJson = $this->getParam('shipping_address');
            $shippingAddress = json_decode(stripslashes(urldecode($shippingAddressJson)), true);
            $this->exportAddressToRequest($shippingAddress);
            $this->addAddress(prepare_address());
        }
        $this->setSuccess(ServiceFactory::factory('Checkout')->detail());
    }

    private function exportAddressToRequest($address) {
        foreach ($address as $key => $val) {
            $_REQUEST[$key] = $val;
        }
    }

}

?>
