<?php

if (!defined('IN_KANCART')) {
    header('HTTP/1.1 404 Not Found');
    die();
}

class kancart_shoppingcart_checkout_action extends UserAuthorizedAction {

    public function validate() {
        if (parent::validate()) {
            if (MODULE_PAYMENT_PAYPAL_STANDARD_STATUS == 'True') {
                return true;
            }
        }
        $this->setError('');
        return false;
    }

    public function execute() {
        global $payment, $order;
        $returnUrl = $this->getParam('return_url');
        $cancelUrl = $this->getParam('cancel_url');
        if (!class_exists('order')) {
            require(DIR_WS_CLASSES . 'order.php');
        }
        $order = new order;
        $payment = 'paypal_standard';
        $paymentService = ServiceFactory::factory('Payment');
        if (!class_exists('shipping')) {
            require(DIR_WS_CLASSES . 'shipping.php');
        }
        $shipping_modules = new shipping();
        global $order_total_modules;
        require(DIR_WS_CLASSES . 'order_total.php');
        $order_total_modules = new order_total;
        $order_total_modules->process();
        $paymentModules = $paymentService->getPaymentModules($payment);
        if (!tep_session_is_registered('payment')) {
            tep_session_register('payment');
        }
        $paymentModules->update_status();
        if (is_array($paymentModules->modules)) {
            $paymentModules->pre_confirmation_check();
        }
        global $$payment;
        $form_action_url = $$payment->form_action_url;
        $paymentModules->confirmation();
        $paypalParams = ServiceFactory::factory('Checkout')->buildWpsRedirectParams($GLOBALS[$paymentModules->selected_module], $returnUrl, $cancelUrl);
        $this->setSuccess(array(
            'paypal_redirect_url' => $form_action_url,
            'paypal_params' => $paypalParams)
        );
    }

}

?>