<?php

if (!defined('IN_KANCART')) {
    header('HTTP/1.1 404 Not Found');
    die();
}

global $language;
include_once (DIR_WS_LANGUAGES . $language . '/' . FILENAME_SHOPPING_CART);

class kancart_shoppingcart_update_action extends BaseAction {

    public function validate() {
        if (!parent::validate()) {
            return false;
        }
        $cartItemId = $this->getParam('cart_item_id');
        $qty = $this->getParam('qty');
        $validateInfo = array();
        if (!isset($cartItemId)) {
            $validateInfo[] = 'Cart item id is not specified .';
        }
        if (!isset($qty) || !is_numeric($qty) || $qty <= 0) {
            $validateInfo[] = 'Qty is not valid.';
        }
        if ($validateInfo) {
            $this->setError(KancartResult::ERROR_CART_INPUT_PARAMETER, $validateInfo);
            return false;
        }
        return true;
    }

    public function execute() {

        $cartItemId = $this->getParam('cart_item_id');
        $qty = $this->getParam('qty');

        $cartService = ServiceFactory::factory('ShoppingCart');

        $productId = explode('{', $cartItemId);
        $productQuantity = $cartService->getProductQuantity($productId[0]);
        if ($qty > $productQuantity) {
            $cartService->update($cartItemId, $qty);
            $result = $cartService->get();
            if (STOCK_ALLOW_CHECKOUT == 'true') {
                $result['messages'] = array(OUT_OF_STOCK_CAN_CHECKOUT);
            } else {
                $result['messages'] = array(OUT_OF_STOCK_CANT_CHECKOUT);
            }
            $this->setSuccess($result);
        } else if ($qty > 0) {
            $cartService->update($cartItemId, $qty);
            $result = $cartService->get();
            $this->setSuccess($result);
        }else{
            $this->setError();
        }
    }

}

?>
