<?php

define('IN_KANCART', true);
define('API_VERSION', '1.1');
define('KC_DEBUG_MODE', false);
define('KANCART_ROOT', str_replace('\\', '/', dirname(__FILE__)));
chdir('..');

require_once 'includes/application_top.php';
require_once KANCART_ROOT . '/configure.php';
require_once KANCART_ROOT . '/util/CryptoUtil.php';
require_once KANCART_ROOT . '/ActionFactory.php';
require_once KANCART_ROOT . '/ServiceFactory.php';
require_once KANCART_ROOT . '/KancartResult.php';
require_once KANCART_ROOT . '/Exceptions.php';
require_once KANCART_ROOT . '/actions/BaseAction.php';
require_once KANCART_ROOT . '/actions/UserAuthorizedAction.php';
require_once KANCART_ROOT . '/common-functions.php';
require_once KANCART_ROOT . '/version.php';
require_once KANCART_ROOT . '/Logger.php';
init();
date_default_timezone_set('UTC');
try {
    $actionInstance = ActionFactory::factory($_REQUEST['method']);
    $actionInstance->init();
    if ($actionInstance->validate()) {
        $actionInstance->execute();
    }
    $result = $actionInstance->getResult();
    die(json_encode($result->returnResult()));
} catch (EmptyMethodException $e) {
    die('KanCart OpenAPI v' . API_VERSION . ' is installed. osCommerce Plugin ' . KANCART_PLUGIN_VERSION);
} catch (Exception $e) {
    die(json_encode(array('result' => KancartResult::STATUS_FAIL, 'code' => KancartResult::ERROR_UNKNOWN_ERROR, 'info' => 'Exception occured.')));
}
?>
