<?php

if (!defined('IN_KANCART')) {
    header('HTTP/1.1 404 Not Found');
    die();
}

/**
 * ShippingService
 *
 * Note:please ensure that there exists only instance at any time
 */
class ShippingService {

    private $shippingModules = null;

    public function getShippingModules() {
        global $cartID, $cart, $total_weight, $total_count, $free_shipping, $order;
        if ($this->shippingModules) {
            return $this->shippingModules;
        }
        if (!class_exists('order')) {
            include(DIR_WS_CLASSES . 'order.php');
        }
        $order = new order;
        // register a random ID in the session to check throughout the checkout procedure
        // against alterations in the shopping cart contents
        if (!tep_session_is_registered('cartID'))
            tep_session_register('cartID');
        $cartID = $cart->cartID;
        $total_weight = $cart->show_weight();
        $total_count = $cart->count_contents();
        require_once(DIR_WS_CLASSES . 'shipping.php');
        $shipping_modules = new shipping;
        if (defined('MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING') && (MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING == 'true')) {
            $pass = false;
            switch (MODULE_ORDER_TOTAL_SHIPPING_DESTINATION) {
                case 'national':
                    if ($order->delivery['country_id'] == STORE_COUNTRY) {
                        $pass = true;
                    }
                    break;
                case 'international':
                    if ($order->delivery['country_id'] != STORE_COUNTRY) {
                        $pass = true;
                    }
                    break;
                case 'both':
                    $pass = true;
                    break;
            }
            $free_shipping = false;
            if (($pass == true) && ($order->info['total'] >= MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING_OVER)) {
                $free_shipping = true;
            }
        } else {
            $free_shipping = false;
        }
        if (!tep_session_is_registered('shipping')) {
            tep_session_register('shipping');
        }
        return $this->shippingModules = $shipping_modules;
    }

}

?>
